config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: 'home#index'
  # Genera las rutas
  resources :employees, except: [:show]
  resources :records
  resources :search
  resources :profiles, only: [:show, :edit, :update]
  resources :documents

  get 'report', to: 'reports#report'
  post 'report', to: 'reports#report'

  get 'export', to: 'reports#export'
  post 'export', to: 'reports#export'

  get 'searchInCalendar', to: 'search#calendar'
  post 'searchInCalendar', to: 'search#calendar'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/employee.rb
class Employee < ApplicationRecord
    has_many :records
end

app/controllers/employees_controller.rb
class EmployeesController < ApplicationController
    before_action :authenticate_user!
    # Filtros -  establecemos la categoría solo para -->
    before_action :set_employee, only: [:edit, :update, :destroy]
  
    def index
      @empleados = Employee.all
    end
  
    def show
      
    end
  
    def new
      @empleado = Employee.new
    end
  
    def edit
    end
  
    def create
      @empleado = Employee.new(employee_params)
  
      respond_to do |format|
        if @empleado.save
          format.json { head :no_content }
          format.js
        else
          format.json { render json: @empleado.errors.full_messages, status: unprocessable_entity }
          format.js { render :new }
        end
      end
    end
  
    def update
      respond_to do |format|
        if @empleado.update(employee_params)
          format.json { head :no_content }
          format.js
        else
          format.json { render json: @empleado.errors.full_messages, status: unprocessable_entity }
          format.js { render :edit }
        end
      end
    end
  
    def destroy
      @empleado.destroy
      respond_to do |format|
        format.json { head :no_content }
        format.js
      end
    end
  
    private
      def set_employee
        @empleado = Employee.find(params[:id])
      end
  
      def employee_params
        params.require(:employee).permit(:nombre, :apellido)
      end
  end
  

app/views/employees/_form.html.erb
<%= form_for @empleado, remote: true do |f| %>

    <div class="item form-group<%= @empleado.errors[:nombre].any? ? ' has-error has-feedback' : '' %>">
      <%= f.label :nombre, "Nombre: " %>
      <div class="input-group">
        <%= f.text_field :nombre, {:class=> "form-control"} %>        
        <%if @empleado.errors[:nombre].any? %>
          <p class="bg-danger"><%= @empleado.errors[:nombre].to_s[/\w([^"]*)/] %></p>
        <% end %>
      </div>
    </div>

    <div class="item form-group<%= @empleado.errors[:apellido].any? ? ' has-error has-feedback' : '' %>">
      <%= f.label :apellido, "Apellido: " %>
      <div class="input-group">
        <%= f.text_field :apellido, {:class=> "form-control"} %>        
        <%if @empleado.errors[:apellido].any? %>
          <p class="bg-danger"><%= @empleado.errors[:apellido].to_s[/\w([^"]*)/] %></p>
        <% end %>
      </div>
    </div>

    <div class="actions col-md-9 col-sm-9 col-xs-12 col-md-offset-3">
      <%= f.submit @empleado.new_record? ? "Crear Empleado" : "Actualizar Empleado", :class => "btn btn-success"%>
    </div>  
<% end %>

app/views/employees/_modal_empleados.html.erb
<!-- Modal -->
<div class="modal fade" id="modalEmpleados" tabindex="-1" role="dialog" aria-labelledby="modalEmpleadosLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="modal-empleados-title">Modal title</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body-empleados modal-body" id="modal-body-empleados">
         
      </div>
      <div class="modal-footer" id="modal-footer-empleados">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
      </div>
    </div>
  </div>
</div>

app/views/employees/create.js.erb
$('#modalEmpleados').modal('toggle');
$('#tablaEmpleados').append(
    '<tr id="empleado_<%= @empleado.id %>"><td class = "text-center"><%= @empleado.id %></td><td><%= @empleado.nombre + ", " + @empleado.apellido %></td><td class = "text-center"><%= link_to "Calendario", searchInCalendar_path(:id => @empleado.id), html_options = {class: "btn btn-primary"} %></td><td class = "text-center"><%= link_to 'editar', edit_employee_path(@empleado), html_options = {class: "btn btn-info btn-xs", remote: true} %></td><td class = "text-center"><%= link_to "borrar", @empleado, remote: true, method: :delete, data: { confirm: "¿Borrar empleado: #{@empleado.nombre}?"}, class: "btn btn-danger btn-xs" %></td></tr>'
);

app/views/employees/destroy.js.erb
$('#empleado_<%= @empleado.id %>').fadeOut();

app/views/employees/edit.js.erb
$('#modal-empleados-title').html("Editar empleado");

$('.modal-body-empleados').html('<%= j render("form") %>');
 
$('#modalEmpleados').modal("show");

app/views/employees/index.html.erb
<h1 class="h3 mb-2 text-gray-800">Lista de Empleados</h1>

<div>  
  <%= link_to new_employee_path, {remote: true, class: "btn btn-info", id: "anadir-categoria-btn"}  do %>
    <span class="fas fa-plus-square"> Nuevo Empleado</span>
  <% end %>
</div>

<br />

<div class="card shadow mb-4">
    <div class="card-boddy">
        <div class="table-responsive">
            <table id="tablaEmpleados" class="table table-bordered" width="100%">
                <thead>
                    <tr>
                        <th class = "text-center">#</th>
                        <th>Nombre / Apellido</th>
                        <th></th>
                        <th></th>
                        <th></th>
                    </tr>
                </thead>

                <tbody>
                <% @empleados.each do |e| %>
                    <tr id = "empleado_<%= e.id %>">
                        <td class = "text-center"><%= e.id %></td>
                        <td><%= e.nombre + ", " + e.apellido %></td>
                        <td class = "text-center"><%= link_to "Calendario", searchInCalendar_path(:id => e.id), html_options = {class: "btn btn-primary"} %></td>
                        <td class = "text-center"><%= link_to "editar", edit_employee_path(e), html_options = {class: "btn btn-info btn-xs", remote: true} %></td>
                        <td class = "text-center"><%= link_to 'borrar', e, remote: true, method: :delete, data: {confirm: "¿Eliminar empleado: #{e.nombre}?"}, class: "btn btn-danger btn-xs"%></td>
                    </tr>
                <% end %>
                </tbody>
            </table>
        </div>
    </div>
</div>

<%= render 'modal_empleados' %>

app/views/employees/new.js.erb
$('#modal-empleados-title').html("Nuevo Empleado");

$('.modal-body-empleados').html('<%= j render("form") %>');

$('#modalEmpleados').modal("show");

app/views/employees/update.js.erb
$('#modalEmpleados').modal('toggle');
$('#empleado_<%= @empleado.id %>').replaceWith(
    '<tr id="empleado_<%= @empleado.id %>"><td class = "text-center"><%= @empleado.id %></td><td><%= @empleado.nombre + ", " + @empleado.apellido %></td><td class = "text-center"><%= link_to "Calendario", searchInCalendar_path(:id => @empleado.id), html_options = {class: "btn btn-primary"} %></td><td class = "text-center"><%= link_to 'editar', edit_employee_path(@empleado), html_options = {class: "btn btn-info btn-xs", remote: true} %></td><td class = "text-center"><%= link_to "borrar", @empleado, remote: true, method: :delete, data: { confirm: "¿Borrar empleado: #{@empleado.nombre}?"}, class: "btn btn-danger btn-xs" %></td></tr>'
);